

#pragma once

#include "cxom_helpers.h"

// header declaration /////////////////////////////////////////////////////
//
// cxom : cross-platform object model
//
// S.Rodriguez - July 2004
//
//



typedef int (t_methodvptr)();

#define CXOM_DEFAULT(type) \
	typedef (type::*t_m)(va_list* argList); \
	_HashTable<t_m> m_htVptrs;

#define CXOM_INDEXER(objecttype) \
	objecttype* Item(char* id); \
	objecttype* operator[](char* id); \
	int	Count();

#define CXOM_METHOD(methodname) \
	int methodname(va_list* argList);

#define CXOM_METHOD_REGISTER(methodname, methodvptr) \
	m_htVptrs.Add( #methodname , methodvptr);


#define CXOM_METHOD_GENERICDECL(type) \
	int MethodCall(char* methodname, ...) \
	{ \
		typedef (type::*tt_m)(va_list* argList); \
		tt_m pfunc = m_htVptrs.Lookup(methodname,NULL); \
		if (!pfunc) \
			return 0; \
		 \
		va_list argList; \
		va_start(argList, methodname); \
		 \
		return (this->*pfunc)(&argList); \
		\
		va_end(argList); \
	}




class IBase
{
protected:
	void* m_cpBase;
public:
	IBase()
	{
		m_cpBase = NULL;
	}
	void SetBase(void* pBase)
	{
		m_cpBase = pBase;
	}
	void* GetBase()
	{
		return m_cpBase;
	}

};
